Codeforces Round #445 (Div. 2) D - Restoration of string 思维 图论

题目链接: D - Restoration of string

题目大意

给你一个字符串集合, 集合中每个字符串都是原字符串中作为子串出现次数最多的子串, 求出原字符串(如果有多个输出字典序最小的)

思路

因为集合中的所有字符串都是出现次数最多的子串, 所以它们在原串中出现的次数应该都是一样的, 而且因为要字典序最小, 所以出现的次数肯定都为1, 所以最后的字符串中肯定不能有其他子串出现超过一次
建一张有向图, 节点是所有子串中出现过的字母, 对于所有子串, 我们将前一个字母向后一个字母连边, 最后得到一张有向图. 这种图中包含了所有子串
要保证不出现超过一次的子串, 那么这张图一定是由若干条链组成, 如果有分支, 为了让所有子串都出现, 那么分支点及其之前的串一定会出现多次.
也不能有环

题解:
If some string is the most frequent then all its substrings are the most frequent too.
If string ab or similar is the most frequent then letter a is always followed by letter b and b always follow a.
Let’s consider directed graph on letters where edge a → b exists only if ab is the most frequent. If there is cycle in such graph then good string doesn’t exist.
So such graph can be represented as several non-intersecting paths. All strings which correspond to paths must occur in non-empty good string. So if we print them in lexicographical order then we will get the answer.

代码

#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <set>
#include <map>
#include <vector>

using namespace std;

const int maxn = 2e5+100;

int n;
bool d[30][30], t[30][30], vist[30];
void dfs(int s, string & str)
{
    str += 'a'+s;
    for(int i=0; i<26; ++i)
        if(d[s][i]) dfs(i, str);
}
int main()
{
    cin >> n;
    for(int i=0; i<n; ++i)
    {
        string s;
        cin >> s;
        for(int i=0; i<(int)s.size(); ++i) vist[s[i]-'a'] |= 1;
        for(int i=1; i<(int)s.size(); ++i) d[s[i-1]-'a'][s[i]-'a'] |= 1;
    }
    for(int i=0; i<26; ++i)//不能有支路(每个节点最多只有一个前驱和一个后继)
    {
        int cnt1 = 0, cnt2 = 0;
        for(int j=0; j<26; ++j)
            cnt1 += d[i][j], cnt2 += d[j][i];
        if(cnt1>1 || cnt2>1)
        {
            puts("NO");
            return 0;
        }
    }
    memcpy(t, d, sizeof(t));
    for(int k=0; k<26; ++k)//不能有环
        for(int i=0; i<26; ++i)
            for(int j=0; j<26; ++j)
                t[i][j] |= (t[i][k] & t[k][j]);
    for(int i=0; i<26; ++i)
        if(t[i][i]) 
        {
            puts("NO");
            return 0;
        }

    vector<string> v;//存储所有链
    for(int i=0; i<26; ++i)
    {
        bool flag = 1;
        for(int j=0; j<26; ++j) //如果没有前驱, 说明这个点是首节点
        {
            if(t[j][i])
            {
                flag = 0;
                break;
            }
        }
        if(flag && vist[i])
        {
            string s;
            dfs(i, s);
            v.push_back(s);
        }
    }
    //排序使得最后得到的串字典序最小
    sort(v.begin(), v.end(), 
        [](const string & a, const string & b)->bool
        {
            string s1 = a+b, s2 = b+a;
            return s1 < s2; 
        });
    for(string s : v) cout << s;

    return 0;
}

猜你喜欢

转载自blog.csdn.net/litmxs/article/details/78535388